SIMON128::Base Class Reference

SIMON128 block cipher base implementation. More...

`#include <simon.h>`

Inheritance diagram for SIMON128::Base:

## Public Member Functions

std::string | AlgorithmName () const
| The algorithm name.
std::string | AlgorithmProvider () const
unsigned int | OptimalDataAlignment () const
| Provides input and output data alignment for optimal performance.
Public Member Functions inherited from BlockCipherImpl< SIMON_Info< 16, 16, 16, 32 > >
unsigned int | BlockSize () const
| Provides the block size of the algorithm.
Public Member Functions inherited from AlgorithmImpl< SimpleKeyingInterfaceImpl< TwoBases< BlockCipher, SIMON_Info< 16, 16, 16, 32 > > > >
std::string | AlgorithmName () const
| The algorithm name.
Public Member Functions inherited from SimpleKeyingInterfaceImpl< TwoBases< BlockCipher, SIMON_Info< 16, 16, 16, 32 > > >
size_t | MinKeyLength () const
| The minimum key length used by the algorithm.
size_t | MaxKeyLength () const
| The maximum key length used by the algorithm.
size_t | DefaultKeyLength () const
| The default key length used by the algorithm.
size_t | GetValidKeyLength (size_t keylength) const
| Provides a valid key length for the algorithm.
SimpleKeyingInterface::IV_Requirement | IVRequirement () const
| The default IV requirements for the algorithm.
unsigned int | IVSize () const
| The initialization vector length for the algorithm.

## Additional Inherited Members

Static Public Member Functions inherited from AlgorithmImpl< SimpleKeyingInterfaceImpl< TwoBases< BlockCipher, SIMON_Info< 16, 16, 16, 32 > > > >
static std::string | StaticAlgorithmName ()
| The algorithm name.

## Detailed Description

SIMON128 block cipher base implementation.

Provides implementation common to encryption and decryption

Since
  Crypto++ 6.0

Definition at line 151 of file simon.h.

## Member Function Documentation

## AlgorithmName()

std::string SIMON128::Base::AlgorithmName | ( |  | ) | const

inline

The algorithm name.

Returns
  the algorithm name

AlgorithmName returns the algorithm's name as a member function.

Definition at line 158 of file simon.h.

## AlgorithmProvider()

std::string SIMON128::Base::AlgorithmProvider | ( |  | ) | const

Definition at line 312 of file simon.cpp.

## OptimalDataAlignment()

unsigned int SIMON128::Base::OptimalDataAlignment | ( |  | ) | const

Provides input and output data alignment for optimal performance.

Returns
  the input data alignment that provides optimal performance

See also
  GetAlignment() and OptimalBlockSize()

Definition at line 331 of file simon.cpp.

The documentation for this class was generated from the following files:

- simon.h
- simon.cpp